<?php
	//Display page errors when needed
	//ERROR_REPORTING(E_ALL);
	//ini_set("display_errors","1");

	//Turn magic quotes off!
	ini_set('magic_quotes_gpc', 'off');
	ini_set('magic_quotes_runtime', 'off');

	require('includes/header.php');

	$numdb = count($databases);
	$self = curPageURL();

	//If any form elements are set, validate them. Should be $_GET, not post

	$valid=false;

	foreach($_GET as $k => $v)
	{
		//If this is a check box attribute
		if (strpos($k, "check") !== false)
		{
			if ($v == 'on') $CheckBoxes[$k] = 1;
			else $CheckBoxes[$k] = 0;
		}
		//If this is a field attribute
		else if (strpos($k, "field") !== false)
		{
			if ($k == 'fieldProfName')
			{
				$profname = $v;
			}
			else if ($k == 'fieldCourseName')
			{
				$coursename = $v;
			}
			else if ($k == 'fieldEmail')
			{
				$email = $v;
			}
			else if ($k == 'fieldSearchName')
			{
				$searchname = $v;
			}
			else if ($k == 'fieldDesc')
			{
				$desc = $v;
			}
		}
	}

	if (!isset($CheckBoxes)) $numcb = 0;
	else $numcb = count($CheckBoxes);

	//Check and see if we have a valid form
	if ($numcb > 0 && $numcb < 11) $ValidCheckBoxes = true;
	else $ValidCheckBoxes = false;

	if (ereg("^[a-zA-Z[:space:]\.]+$", $profname)) $ValidProfName = true;
	else $ValidProfName = false;

	if (ereg("^[a-zA-Z0-9[:space:]\.]+$", $coursename)) $ValidCourseName = true;
	else $ValidCourseName = false;

	if (ereg("^[a-zA-Z0-9()[:space:]\.]+$", $searchname)) $ValidSearchName = true;
	else $ValidSearchName = false;

	if (ereg(".*@.*\..*", $email)) $ValidEmail = true;
	else $ValidEmail = false;

	$desc = htmlentities($desc);

	//If everything is valid, generate the code and either display the e-mail/save/copy box,
	//Or send it as a file (if $_GET['save'] is set)
	if ($ValidCheckBoxes && $ValidProfName && $ValidCourseName && $ValidEmail && $ValidSearchName)
	{
		$valid = true;

		//Generate the code
		//First, read in the header part
		$gen = "";
		$file = fopen('html/genhead.html', "r");
       	while(!feof($file))
		{
           	$gen = $gen . fgets($file, 4096);
       	}
       	fclose ($file);
		
		//Next, replace the needed areas with our variables
		$gen = str_replace("{--COURSENAME--}", $coursename, $gen);
		$gen = str_replace("{--PROFNAME--}", $profname, $gen);
		$gen = str_replace("{--SEARCHNAME--}", $searchname, $gen);
		$gen = str_replace("{--DESC--}", $desc, $gen);
		$gen = str_replace("{--DBLINK1--}", $DBLink1, $gen);
		$gen = str_replace("{--DBLINK2--}", $DBLink2, $gen);
		$gen = str_replace("{--FILTERIP--}", $FilterIP, $gen);

		//Third, generate the databases section
		$gen .= '
				<tr>
					<td width=33% align="left" valign="top" bgcolor="#EFEEF4">
						<font size=2>
			';

		$i = 0;
		$canprinttd = false;
		foreach($databases as $dbname => $dbvar)
		{
			$cbname = "check" . $dbvar['ckbox'];
		
			//If the checkbox should be included
			if (isset($CheckBoxes["$cbname"]))
			{
				if ($CheckBoxes["$cbname"] == 1)
				{
					$gen .= "
								<br>
								<input TYPE=\"checkbox\" NAME=\"cat\" SIZE=\"1\" value=\"&ckbox={$dbvar['ckbox']}\"checked>
								<a href=\"{$dbvar['link']}\">$dbname</a>
					";
					$i++;
					$canprinttd = true;
				}
			}

			//If we are 1/3rd, or 2/3rds of the way there, then start a new cell
			if (($i == ceil(($numcb / 3)) || $i == (ceil(($numcb / 3)) * 2)) && $canprinttd)
			{
				$gen .= '		</font>
					</td>
					<td width=33% align="left" valign="top" bgcolor="#EFEEF4">
						<font size=2>
					';
				$canprinttd = false;
			}
		}

		$gen .= "
					</font>
				</td>
			</tr>
			";

		//Finally, read in the footer
		$file = fopen('html/genfoot.html', "r");
       		while(!feof($file)) {
           		$gen = $gen . fgets($file, 4096);
       		}
       		fclose ($file);


		//Now, we either send the result as a file, as an e-mail, 
		//or print options to do so
		if (isset($_GET['send']))
		{
			header("Content-type: application/file");
			header('Content-Disposition: attachment; filename="search.html"');
			
			print($gen);

			$to = $your_email;
			$subject = "$email's Generated Search Form";
			$body = $gen;
			$headers = "From: $your_email" . "\r\n" .
   				"Reply-To: $your_email" . "\r\n" .
   				'X-Mailer: PHP/' . phpversion();
			mail($to, $subject, $body, $headers);

			die();
		}
		else if (isset($_GET['email']))
		{
			$to = $email;
			$subject = "Generated Search Form";
			$body = $gen;
			$headers = "From: $your_email" . "\r\n" .
   				"Reply-To: $your_email" . "\r\n" .
				"BCC: $your_email" . "\r\n" .
   				'X-Mailer: PHP/' . phpversion();
			if (mail($to, $subject, $body, $headers))
			{
				print("
					<table width='100%'>
						<tr>
							<td width='100%' align='left' valign='center' bgcolor='#EFFEE4'>
								Message successfully sent to $email!
							</td>
						</tr>
					</table>
				");
 			} 
			else
			{
				print("
					<table width='100%'>
						<tr>
							<td width='100%' align='left' valign='center' bgcolor='#EFFEE4'>
								Message delivery failed... unable to send to $email. Please try again, or use a different option to obtain the code.
							</td>
						</tr>
					</table>
				");
 			}

			$self = str_replace('&email=1', '', $self);
		}
		else if (isset($_GET['preview']))
		{
			$gobackurl = str_replace('&preview=1', '', $self);

			print("
				<table width='100%'>
					<tr>
						<td width='100%' align='left' valign='center' bgcolor='#EFFEE4'>
							Previewing generated page. Click <a href='$gobackurl'>HERE</a> to return to generator.
						</td>
					</tr>
				</table>
			");

			print($gen);

			die();
		}

		//In any case (if we havn't died) print the send options
		print("
			<table>
				<tr>
					<td width='100%' align='left' valign='top' bgcolor='#EFEEF4'>
						Form Successfully Validated! Please use one of the options below to obtain your generated code:
					</td>
				<tr>
			</table>
			<br>
			<a href='$self&preview=1'>Preview page</a> 
			<a href='$self&email=1'>Email to $email</a> 
			<a href='$self&send=1'>Download as file</a>
			<br>
			<br>
		");

		//Print a box with the code in it
		print("
			Or copy the code from the box below:
			<form>
				<textarea cols='90' rows='20' wrap='off' READONLY onClick='javascript:this.select();'>
					$gen
				</textarea>
			</form>
		");

		//And the below stuff
		print('
			<br>
			<br>
			<table width="100%">
				<tr>
					<td width="100%" align="left" valign="top" bgcolor="#EFEEF4">
						You can modify your choices below. Be sure to click "Generate Form" again after making any changes, or they will not be included!
					</td>
				<tr>
			</table>
			<br>
			<br>
		');
		
	}
	else $valid = false;


	//Start page generation
	print("
		<title>Panther Prowler Search Form Generator</title>
		Fill out this page to generate an HTML search form that can be loaded
		in WebCT or elsewhere. Please fill in all fields, and select between 1 and 10
		databases.
		<br>
		<br>
	");

	//If we had submitted the form and their were errors, plop them out in red here
	if (isset($_GET['validate']) && $valid == false)
	{
		print('<font color="#FF0000">Some errors were found, please correct them and click "Generate Form" again:<br><br></font>');
		if (!$ValidCheckBoxes) print('<font color="#FF0000">Please check between 1 and 10 databases to include</font><br>');
		if (!$ValidProfName) print('<font color="#FF0000">Please enter the professor\'s name. Use letters, spaces and periods only.</font><br>');
		if (!$ValidCourseName) print('<font color="#FF0000">Please enter the course\'s name. Use letters, spaces, numbers and periods only.</font><br>');
		if (!$ValidSearchName) print('<font color="#FF0000">Please enter a title for the search. Use letters, spaces, numbers and periods only.</font><br>');
		if (!$ValidEmail) print('<font color="#FF0000">Please enter a valid email in the form of "someone@something.something".</font><br>');
		print("<br><br>");
	}

	//The start of the form
	print('
		<!--Form Start-->
		<FORM action="generate.php" method="get">
	');

	//The required info section
	print("<table>");
	print("<tr><td>Title for search: </td><td><input TYPE=\"text\" SIZE=\"60\" NAME=\"fieldSearchName\" value=\"$searchname\"></td></tr>");
	print("<tr><td>Professor's Name: </td><td><input TYPE=\"text\" SIZE=\"60\" NAME=\"fieldProfName\" value=\"$profname\"></td></tr>");
	print("<tr><td>Course Name: </td><td><input TYPE=\"text\" SIZE=\"60\" NAME=\"fieldCourseName\" value=\"$coursename\"></td></tr>");
	print("<tr><td>Description (optional): </td><td><input TYPE=\"text\" SIZE=\"60\" NAME=\"fieldDesc\" value=\"$desc\"></td></tr>");
	print("<tr><td>Your Email: </td><td><input TYPE=\"text\" SIZE=\"60\" NAME=\"fieldEmail\" value=\"$email\"></td></tr>");
	print("</table><br>");
	print('
		Click "Generate Form" to continue. Reset resets the form\'s values to what they were when the page loaded. Clear clears entered data, blanking the form.<br>
		<INPUT type="submit" value="Generate Form"> <INPUT type="reset" value="Reset Form"> <INPUT TYPE="button" value="Clear Form" onClick="parent.location=\'generate.php\'">
		<br>
		<br>
	');

	//The "select your databases" section
	print('
		<table>
			<tr>
				<td colspan=3 align="center" valign="top" bgcolor="#EFEEF4">
					Check boxes to include up to ten databases ('.$numcb.' currently selected)<br>
					<font size=-2>
						<b>(Database links point to native search interfaces)</b>
					</font>
				</td>
			</tr>
			<tr>
				<td width=33% align="left" valign="top" bgcolor="#EFEEF4">
					<font size=2>
	');

	$i = 1;
	foreach($databases as $dbname => $dbvar)
	{
		$cbname = "check" . $dbvar['ckbox'];
		
		//If the checkbox should be checked..
		if (isset($CheckBoxes["$cbname"]))
		{
			if ($CheckBoxes["$cbname"] == 1)
			{
				print("
						<br>
						<input TYPE=\"checkbox\" NAME=\"$cbname\" SIZE=\"1\" checked>
						<a href=\"{$dbvar['link']}\">$dbname</a>
				");
			}
			else
			{
				print("
							<br>
							<input TYPE=\"checkbox\" NAME=\"$cbname\" SIZE=\"1\">
							<a href=\"{$dbvar['link']}\">$dbname</a>
				");
			}
		}
		else
		{
			print("
						<br>
						<input TYPE=\"checkbox\" NAME=\"$cbname\" SIZE=\"1\">
						<a href=\"{$dbvar['link']}\">$dbname</a>
			");
		}

		//If we are 1/3rd, or 2/3rds of the way there, then start a new cell
		if ($i == floor(($numdb / 3)) || $i == (floor(($numdb / 3)) * 2))
		{
			print('		</font>
				</td>
				<td width=33% align="left" valign="top" bgcolor="#EFEEF4">
					<font size=2>
			');
		}

		$i++;
	}

	print("
					</font>
				</td>
			</tr>
		</table>
	");

	//End of form generation
	print('
		Click "Generate Form" to continue. Reset resets the form\'s values to what they were when the page loaded. Clear clears entered data, blanking the form.<br>
		<INPUT type="hidden" name="validate" value="1">
		<INPUT type="submit" value="Generate Form"> <INPUT type="reset" value="Reset Form"> <INPUT TYPE="button" value="Clear Form" onClick="parent.location=\'generate.php\'">
		</FORM>
	');

	function curPageURL()
	{
 		$pageURL = 'http';
 		if (isset($_SERVER["HTTPS"]))
 		{
 			if ($_SERVER["HTTPS"] == "on") {$pageURL .= "s";}
		}
		$pageURL .= "://";
 		if ($_SERVER["SERVER_PORT"] != "80")
		{
  			$pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
 		} 
		else 
		{
  			$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
 		}
 		return $pageURL;
	}
?>